#include <dos.h>

unsigned char snd_buf_state;
unsigned drum_mode;
unsigned active_voice;
unsigned transpose_value;
unsigned play_state;

void init_driver(void)
{
	union REGS r;

	r.x.si = 0;
	int86(0x65, &r, &r);
}

void disable_driver(void)
{
	union REGS r;

	r.x.si = 1;
	int86(0x65, &r, &r);
}

void set_starttime(unsigned int timenum, unsigned int timeden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 2;
	seg.es = FP_SEG(&timenum);
	r.x.bx = FP_OFF(&timenum);
	int86x(0x65, &r, &r, &seg);
}

void set_state(unsigned int state)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 3;
	seg.es = FP_SEG(&state);
	r.x.bx = FP_OFF(&state);
	int86x(0x65, &r, &r, &seg);
}

void get_state(void)
{
	union REGS r;

	r.x.si = 4;
	int86(0x65, &r, &r);
	play_state= r.x.ax;
}

void sound_off(void)
{
	union REGS r;

	r.x.si = 5;
	int86(0x65, &r, &r);
}

void set_mode(unsigned int mode) // mode=1 <-- drum_mode
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 6;
	seg.es = FP_SEG(mode);
	r.x.bx = FP_OFF(mode);
	int86x(0x65, &r, &r, &seg);
}

void get_mode(void)
{
	union REGS r;

	r.x.si = 7;
	int86(0x65, &r, &r);
	drum_mode= r.x.ax;
}

void set_volume(int volnum, int volden, unsigned int timenum,  unsigned
int timeden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 8;
	seg.es = FP_SEG(&volnum);
	r.x.bx = FP_OFF(&volnum);
	int86x(0x65, &r, &r, &seg);
	snd_buf_state= r.h.al;
}

void set_tempo(unsigned int tempo, unsigned int timenum,  unsigned
int timeden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 9;
	seg.es = FP_SEG(tempo);
	r.x.bx = FP_OFF(tempo);
	int86x(0x65, &r, &r, &seg);
	snd_buf_state= r.h.al;
}

void set_transpose(int d_semitone)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 10;
	seg.es = FP_SEG(d_semitone);
	r.x.bx = FP_OFF(d_semitone);
	int86x(0x65, &r, &r, &seg);
}

void get_transpose(void)
{
	union REGS r;

	r.x.si = 11;
	int86(0x65, &r, &r);
	transpose_value= r.x.ax;
}


/*
	function 12 : set_active_voice
	must set before function 8, 14-17
*/
void set_voice(unsigned int voice)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 12;
	seg.es = FP_SEG(voice);
	r.x.bx = FP_OFF(voice);
	int86x(0x65, &r, &r, &seg);
}

void get_voice(void)
{
	union REGS r;

	r.x.si = 13;
	int86(0x65, &r, &r);
	active_voice = r.x.ax;
}

void put_notedelay(int  pitch,  unsigned  int  lengnum,unsigned   int
lengden, unsigned int delaynum, unsigned int delayden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 14;
	seg.es = FP_SEG(&pitch);
	r.x.bx = FP_OFF(&pitch);
	int86x(0x65, &r, &r, &seg);
	snd_buf_state= r.h.al;
}

void put_note(int  pitch,  unsigned  int  lengnum,  unsigned  int
lengden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 15;
	seg.es = FP_SEG(&pitch);
	r.x.bx = FP_OFF(&pitch);
	int86x(0x65, &r, &r, &seg);
	snd_buf_state= r.h.al ;
}

void set_timbre(int *tptr, unsigned int timenum, unsigned int timeden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 16;
	seg.es = FP_SEG(tptr);
	r.x.bx = FP_OFF(tptr);
	int86x(0x65, &r, &r, &seg);
	snd_buf_state= r.h.al;
}

void set_pitch(int d_octav, int d_pitchnum,  int  d_pitchden,  unsigned
int timenum, unsigned int timeden)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 17;
	seg.es = FP_SEG(&d_octav);
	r.x.bx = FP_OFF(&d_octav);
	int86x(0x65, &r, &r, &seg);
	snd_buf_state= r.h.al;
}

void set_TPB(unsigned int TPB)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 18;
	seg.es = FP_SEG(&TPB);
	r.x.bx = FP_OFF(&TPB);
	int86x(0x65, &r, &r, &seg);
}

void directnoteon(unsigned int voice, int pitch)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 19;
	seg.es = FP_SEG(&voice);
	r.x.bx = FP_OFF(&voice);
	int86x(0x65, &r, &r, &seg);
}

void directnoteoff(unsigned int voice)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 20;
	seg.es = FP_SEG(&voice);
	r.x.bx = FP_OFF(&voice);
	int86x(0x65, &r, &r, &seg);
}

void directtimbre(unsigned int voice, int *timbre)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 21;
	seg.es = FP_SEG(&voice);
	r.x.bx = FP_OFF(&voice);
	int86x(0x65, &r, &r, &seg);
}

void setwhat(unsigned int what)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 22;
	seg.es = FP_SEG(&what);
	r.x.bx = FP_OFF(&what);
	int86x(0x65, &r, &r, &seg);
}

void set_waveform(unsigned int enable)
{
	union REGS r;
	struct SREGS seg;

	r.x.si = 23;
	seg.es = FP_SEG(&enable);
	r.x.bx = FP_OFF(&enable);
	int86x(0x65, &r, &r, &seg);

}

